local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")

vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP", "FFASystem")
vRPCFFA = Tunnel.getInterface("FFASystem", "FFASystem")

vRPSFFA = {}
Tunnel.bindInterface("vRPSFFA", vRPSFFA)


local inFFA = {}
local tempTbl = {};
local timeoutSpam = {};
GlobalState['playersPlaying'] = 0;
GlobalState['currentMap'] = 'Loading...';
GlobalState['statusArena'] = '~r~Inchisa';
GlobalState['FFATimer'] = 0;
timerStarted = false;

local armeFFA = {

    "WEAPON_DOUBLEACTION",
    "WEAPON_GADGETPISTOL",
    "WEAPON_MINISMG",
    "WEAPON_COMBATSHOTGUN",
    "WEAPON_COMBATMG_MK2",
    "WEAPON_SMG_MK2",
    "WEAPON_SPECIALCARBINE_MK2",

}

function generateRandomMap()
    GlobalState['currentMap'] = ffaConfig.numeHarti[math.random(1,#ffaConfig.numeHarti)]
end
CreateThread(function()
    Wait(5000)
    GlobalState['statusArena'] = '~g~Deschisa';
    generateRandomMap()
end)

RegisterNetEvent("FFA:playerDied", function (killer,distCoords)
    local killer = tonumber(killer);
    local player = source;
    if killer == player then killer = -1 end;
    local user_id = vRP.getUserId{player};
    if not user_id then return end;
    vRPCFFA.isInFFAandComa(player, {}, function (InComa)
        if not InComa then return end;
        Player(player).state.FFADeaths = (Player(player).state.FFADeaths or 0) + 1;
        if killer > 0 then
          local killerId = vRP.getUserId{killer};
          if not killerId then return end;
          Player(killer).state.FFAKills = (Player(killer).state.FFAKills or 0) + 1;
          TriggerClientEvent('newKill', -1,vRP.getPlayerName({player}), vRP.getPlayerName({killer}), false, ( GetSelectedPedWeapon(GetPlayerPed(killer)) or -1), math.round(distCoords))
          vRPclient.notify(killer, {"~o~" .. GetPlayerName(killer) .. "~w~ L-a omorat pe ~o~" .. GetPlayerName(player) .. "~w~ Ai primit ~g~+" .. ffaConfig.healthOnKill .. " HP~w~"})
        --   exports.oxmysql:execute("UPDATE vrp_users SET kills = kills + 1 WHERE id = @user_id", {
        --     ["@user_id"] = killerId
        --   });
          vRPclient.varyHealth(killer, {ffaConfig.healthOnKill})
          if math.random(100) <= ffaConfig.armourChance then
            vRPclient.notify(killer, {"Ai primit ~b~+" .. ffaConfig.armourOnKill .. " Armura~w~ pentru ca l-ai omorat pe ~r~" .. GetPlayerName(player)})
            vRPCFFA.varyArmour(killer, {ffaConfig.armourOnKill})
          end
        end
        local coords = ffaConfig.zone[GlobalState.currentMap][math.random(1,#ffaConfig.zone[GlobalState.currentMap])]
        TriggerClientEvent("FFA:respawnPlayer", player, coords[1], coords[2], coords[3], true)
    end)
end)


RegisterCommand('changestatus',function(source,args,rawCommand)
    if not (source == 0) then return end;
    if not args[1] or parseInt(args[1]) > 2 then return print("^1Error: ^0/changestatus [1 - deschis / 0 - inchis]") end;

    if parseInt(args[1]) == 1 then
        GlobalState['statusArena'] = '~g~Deschisa';
        TriggerClientEvent(ffaConfig.triggerChat, -1,ffaConfig.openArena);
    else
        GlobalState['statusArena'] = '~r~Inchisa';
        for k,v in pairs(inFFA) do
            TriggerClientEvent('FFA:respawnPlayer',k,ffaConfig.position[1],ffaConfig.position[2],ffaConfig.position[3], true);
            TriggerClientEvent(ffaConfig.triggerChat,k,ffaConfig.arenaClosedMessage);
            SetPlayerRoutingBucket(k, 0);
            TriggerEvent(ffaConfig.triggerVirtualWorld, k, 0);
            TriggerClientEvent('FFA:changeState',k,false);
            TriggerClientEvent('FFA:updateHud',k);
            inFFA[v] = nil;
        end
        GlobalState['playersPlaying'] = 0;
    end
    print('^2Success: ^0Status-ul arenei a fost modificat cu succes!');
end)

function startTimer(time)
    time = tonumber(time)
    if time > 0 then
        GlobalState['FFATimer'] = time;
        timerStarted = true;
        local maxKills = -1;
        while timerStarted do
            GlobalState['FFATimer'] = (GlobalState['FFATimer'] or 0) - 1;
            if (GlobalState['FFATimer'] or 0) < 1 then
                GlobalState['FFATimer'] = 0;
                for v,k in pairs(inFFA) do
                    if (Player(k).state.FFAKills or 0) then
                        if (Player(k).state.FFAKills or 0) > maxKills then
                            maxKills = k
                        end
                        --RemoveAllPedWeapons(source,true);

                        for k,v in pairs(armeFFA)do
                            RemoveWeaponFromPed(source, GetHashKey(v))
                        end

                        TriggerClientEvent('FFA:respawnPlayer',k,ffaConfig.position[1],ffaConfig.position[2],ffaConfig.position[3], true)
                        SetPlayerRoutingBucket(k, 0);
                        TriggerEvent(ffaConfig.triggerVirtualWorld, k, 0);
                        TriggerClientEvent('FFA:changeState',k,false);
                        GlobalState['playersPlaying'] = 0;
                        inFFA[v] = nil;
                        timeoutSpam[v] = nil;
                        generateRandomMap();

                        SetTimeout(500,function()
                            vRPclient.notify(k, {"Ai primit armele inapoi."})
                            vRPclient.giveWeapons(k,{tempTbl[v],true})
                            tempTbl[v] = nil;
                        end)

                    end
                end
                TriggerClientEvent(ffaConfig.triggerChat, -1, ffaConfig.chatColor.."FFA: ^0Meciul de FFA, s-a terminat.")
                -- vRP.giveBankMoney{vRP.getUserId{maxKills},math.random(tonumber(ffaConfig.minMoneyOnPlayerWin), tonumber(ffaConfig.maxMoneyOnPlayerWin))}
                timerStarted = false;
            end
            Wait(1000)
        end
    end
end

RegisterCommand('joinffa',function(source)
    if (source == 0) then return print('^1Error: ^0Aceasta comanda nu poate fi executata de catre consola.') end
    local coords = GetEntityCoords(GetPlayerPed(source));
    if not coords then return end;
    if #(vector3(coords) - ffaConfig.position) > 5 then return vRPclient.notify(source,{ffaConfig.langNotArena}) end;
    local user_id = vRP.getUserId{source};
    if not user_id then return end;
    if GlobalState['statusArena'] == '~r~Inchisa' then return vRPclient.notify(source,{ffaConfig.ArenaClosedNotify}) end;
    local theJob = vRP.getUserGroupByType({user_id,"job"})
    if tonumber(vRP.getUserHoursPlayed({user_id})) > 2 then
        if(theJob ~= "Traficant Organe")then
            if not inFFA[user_id] then
                if not timeoutSpam[user_id] then
                    GlobalState['playersPlaying'] = GlobalState['playersPlaying'] + 1;        
                    inFFA[user_id] = source;
                    vRPclient.setHealth(source,{200});
                    vRPclient.getWeapons(source,{},function(weapons)
                        tempTbl[user_id] = weapons;
                        vRPclient.giveWeapons(source,{{},true})
                    end)

                    Player(source).state.FFAKills = 0;
                    Player(source).state.FFADeaths = 0;
                    SetTimeout(100,function()
                        local coordsbasina = ffaConfig.zone[GlobalState.currentMap][math.random(1,#ffaConfig.zone[GlobalState.currentMap])]
                        TriggerClientEvent("FFA:respawnPlayer", source, coordsbasina[1], coordsbasina[2], coordsbasina[3], false)
                        TriggerClientEvent('FFA:changeState',source,true);
                        SetPlayerRoutingBucket(source, ffaConfig.virtualWorld);
                        TriggerEvent(ffaConfig.triggerVirtualWorld, source, ffaConfig.virtualWorld);
                        vRPclient.giveWeapons(source,{ffaConfig.weapons,true});
                        if GlobalState['playersPlaying'] >= ffaConfig.playersNeedToStart and (GlobalState['FFATimer'] or 0) < 1 then
                            startTimer(ffaConfig.ffaTimer);
                        end

                        timeoutSpam[user_id] = true;
                        SetTimeout(ffaConfig.spamTimeout * 1000,function()
                            timeoutSpam[user_id] = nil;
                        end)
                    end)
                else
                    vRPclient.notify(source,{"Cooldown! Asteapta "..ffaConfig.spamTimeout.." secunde!"})
                end
            else
                vRPclient.notify(source,{"Esti deja in FFA, foloseste comanda /leaveffa pentru a iesi din arena."});
            end
        else
            vRPclient.notify(source,{"Esti traficant de organe. Nu poti intra la ffa"});
        end
    else
        vRPclient.notify(source,{"Trebuie sa ai cel putin 2 ore jucate pe server"});
    end
end)


AddEventHandler('playerDropped', function(reason)
    if not inFFA[user_id] then return end;
    --RemoveAllPedWeapons(source,true);

    for k,v in pairs(armeFFA)do
        RemoveWeaponFromPed(source, GetHashKey(v))
    end

    GlobalState['playersPlaying'] = GlobalState['playersPlaying']-1;
    inFFA[user_id] = nil;
    tempTbl[user_id] = nil;
end)

AddEventHandler('vRP:playerLeave',function(user_id,source)
    if not inFFA[user_id] then return end;
        inFFA[user_id] = nil;
        --RemoveAllPedWeapons(source,true);

        for k,v in pairs(armeFFA)do
            RemoveWeaponFromPed(source, GetHashKey(v))
        end

        GlobalState['playersPlaying'] = GlobalState['playersPlaying']-1;
end)

RegisterCommand('leaveffa',function(source)
    if (source == 0) then return print("^1Error: ^0Aceasta comanda nu poate fi executata de catre consola.") end;
    local user_id = vRP.getUserId{source};
    if not user_id then return end;
    if inFFA[user_id] then
        GlobalState['playersPlaying'] = GlobalState['playersPlaying']-1;
        inFFA[user_id] = nil;
        --RemoveAllPedWeapons(source,true);

        for k,v in pairs(armeFFA)do
            RemoveWeaponFromPed(source, GetHashKey(v))
        end

        TriggerClientEvent("FFA:respawnPlayer",source,ffaConfig.position[1], ffaConfig.position[2], ffaConfig.position[3],true);
        TriggerClientEvent('FFA:changeState',source,false);
        SetPlayerRoutingBucket(source,0);
        SetTimeout(500,function()
            vRPclient.notify(source,{"Ai primit armele inapoi."})
            vRPclient.giveWeapons(source,{tempTbl[user_id],true})
            tempTbl[user_id] = nil;
        end)
        if timerStarted and (GlobalState['playersPlaying'] or 0) < 2 then
            timerStarted = false;
            startTimer(1);
        end
    else
        vRPclient.notify(source,{"Nu poti folosi aceasta comanda deoarece nu te afli in FFA."});
    end
end)